Subject: Re: [Tsvwg] Re: [e2e] What's the benefit of out-of-order processi

From: David Borman <[email-masked]>
Date: Tue, 18 Sep 2001 08:58:02 -0500 (CDT)

> From: John Wroclawski <[email-masked]>
> Subject: Re: [Tsvwg] Re: [e2e] What's the benefit of out-of-order processi
> Date: Mon, 17 Sep 2001 22:31:55 -0400
>
> At 6:36 PM -0700 9/17/01, Jacob Heitz wrote:
> >The urgent pointer does not point at a range, only at a single
> >byte. It can only deliver a single byte of out-of-band data.
> >
>
> Actually, TCP urgent delivers an out of band _notification_ of the 
> presence of urgent _in band_ data.
> 
> (The idea being that on receiving the notification the app would know 
> to chug through the data stream in whatever way it sees fit until it 
> gets to the 'urgent' part.)

A minor nit.  All the data up to, but not including, the urgent pointer
is the "urgent data".  The urgent pointer points to the first octet
following the urgent data.  But in most cases, what the application
is really interested in is the data after the urgent pointer, sometimes
referred to as the "interesting" data.

The other thing to keep in mind is that the urgent pointer can move,
and is cumulative.  Thus, the urgent pointer might point at "X",
and can then be moved to "X+n" before "X" is processed, or even
sent!  This is how TCP deals with urgent pointers that have more
than a 64K offset.

But I digress.  John is right, the TCP urgent pointer is basicly
out-of-band *notification* of interesting in-band data (and what
"interesting" means is determined by the application).

		-David Borman, [email-masked]

_______________________________________________
tsvwg mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/tsvwg

---

From: Bob Braden <[email-masked]>
Date: Tue, 18 Sep 2001 15:52:36 GMT

*> From [email-masked]  Mon Sep 17 18:46:27 2001
  *> From: Jacob Heitz <[email-masked]>
  *> X-Accept-Language: en
  *> MIME-Version: 1.0
  *> To: Sam Liang <[email-masked]>
  *> CC: "Naidu, Venkata" <[email-masked]>,
  *>    "'Qiaobing Xie'" <[email-masked]>, Craig Partridge <[email-masked]>,
  *>    [email-masked], [email-masked]
  *> Subject: Re: [Tsvwg] Re: [e2e] What's the benefit of out-of-order processi
  *> Content-Transfer-Encoding: 7bit
  *> X-BeenThere: [email-masked]
  *> X-Mailman-Version: 2.0.1
  *> List-Help: <mailto:[email-masked]?subject=help>
  *> List-Archive: <http://www.postel.org/pipermail/end2end-interest/>
  *> Date: Mon, 17 Sep 2001 18:36:25 -0700
  *> 
  *> The urgent pointer does not point at a range, only at a single
  *> byte. It can only deliver a single byte of out-of-band data.
  *> 

This comment reflects a (common) misunderstanding of the urgent pointer
mechanism of TCP.  [It has amazed me for 20 years that people have had
so much trouble with this!]

OSI has an out-of-band data delivery mechanism, limited to a few bytes
of urgent data.  The researchers who designed TCP hated arbitrary
limits, so they DID NOT put an out-of-band delivery mechanism into
TCP.  People keep saying, "Oh, there is an urgent pointer, THAT must be
TCP's OOB delivery mechanism", without stopping to read the spec or
think about it.  It is not!   It does not send even one urgent byte; it
sends NO urgent bytes.

The TCP urgent pointer is an (are you listening?) OUT-OF-BAND
SIGNALING MECHANISM.

Bob Braden

(Why is this discussion taking place on two lists?)

  *> Sam Liang wrote:
  *> > 
  *> >   Also, doesn't TCP's urgent pointer offer a means to deliver out-of-band
  *> > data?
  *>